#include "dulcepan.h"

static void set_selected_output(struct dp_selection *selection, struct dp_output *output) {
	if (selection->output == output) {
		return;
	}
	struct dp_output *prev = selection->output;
	selection->output = output;
	if (prev != NULL) {
		dp_output_redraw(prev);
	}
}

void dp_select_interactive_start(
		struct dp_selection *selection, struct dp_output *output, int x, int y) {
	selection->interactive_output = output;
	selection->interactive_x = x;
	selection->interactive_y = y;
	selection->interactive_moved = false;

	dp_output_redraw(output);
}

void dp_select_interactive_move(struct dp_selection *selection, int x, int y) {
	if (selection->interactive_output == NULL) {
		return;
	}
	set_selected_output(selection, selection->interactive_output);
	selection->interactive_moved = true;

	if (x < selection->interactive_x) {
		selection->x = x;
		selection->width = selection->interactive_x - x;
	} else {
		selection->x = selection->interactive_x;
		selection->width = x - selection->interactive_x;
	}
	if (y < selection->interactive_y) {
		selection->y = y;
		selection->height = selection->interactive_y - y;
	} else {
		selection->y = selection->interactive_y;
		selection->height = y - selection->interactive_y;
	}

	dp_output_redraw(selection->output);
}

void dp_select_interactive_stop(struct dp_selection *selection) {
	selection->interactive_output = NULL;
	selection->interactive_moved = false;
}

void dp_select_whole(struct dp_selection *selection, struct dp_output *output) {
	set_selected_output(selection, output);

	selection->x = 0;
	selection->y = 0;
	selection->width = output->transformed_width;
	selection->height = output->transformed_height;

	dp_output_redraw(output);
}
